﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Interactive;
using Syncfusion.Pdf.Parsing;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace MaximumZoom
{

    public partial class MainPage : ContentPage
    {

        public MainPage()
        {
            InitializeComponent();
            BindingContext = new PdfViewerViewModel();

        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            if (pdfViewerControl.InputFileStream != null)
            {
                MemoryStream stream = HighLightPdf(pdfViewerControl.InputFileStream);
                pdfViewerControl.Unload();
                stream.Position = 0;
                pdfViewerControl.LoadDocument(stream);
            }
        }

        public static MemoryStream HighLightPdf(Stream stream)
        {

            PdfLoadedDocument doc = new PdfLoadedDocument(stream);
            Dictionary<int, List<RectangleF>> matchRect = new Dictionary<int, List<RectangleF>>();

            var matched = doc.FindText("the", out matchRect);
            if (matched)
            {
                foreach (KeyValuePair<int, List<RectangleF>> item in matchRect)
                {
                    PdfLoadedPage page = doc.Pages[item.Key] as PdfLoadedPage;
                    foreach (var rect in item.Value)
                    {

                        PdfTextMarkupAnnotation textannot = new PdfTextMarkupAnnotation(rect);
                        textannot.TextMarkupAnnotationType = PdfTextMarkupAnnotationType.Highlight;
                        textannot.TextMarkupColor = new PdfColor(Syncfusion.Drawing.Color.Yellow);
                        page.Annotations.Add(textannot);
                    }
                }
            }

            MemoryStream memStream = new MemoryStream();
            doc.Save(memStream);
            return memStream;
        }


    }
}
